Bug 1052248 - (CVE-2017-12427) VUL-1: CVE-2017-12427: GraphicsMagick, ImageMagick: ProcessMSLScript coders/msl.c allows remote attackers to cause a DoS
(CVE-2017-12427)
VUL-1: CVE-2017-12427: GraphicsMagick, ImageMagick: ProcessMSLScript coders/m...
Status: RESOLVED FIXED
Classification: Novell Products
Product: SUSE Security Incidents
Classification: Novell Products
Component: Incidents
unspecified
Other Other
: P4 - Low : Normal
: ---
Assigned To: Security Team bot
Security Team bot
https://smash.suse.de/issue/189601/
CVSSv3:SUSE:CVE-2017-12427:7.5:(AV:N/...
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2017-08-04 12:20 UTC by Johannes Segitz
Modified: 2018-03-06 23:45 UTC (History)
3 users (show)

See Also:
Found By: Security Response Team
Services Priority:
Business Priority:
Blocker: ---
Marketing QA Status: ---
IT Deployment: ---


Attachments
Reproducer (2.00 KB, application/octet-stream)
2017-08-04 12:20 UTC, Johannes Segitz
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Johannes Segitz 2017-08-04 12:20:54 UTC
Created attachment 735278 [details]
Reproducer

CVE-2017-12427

The ProcessMSLScript function in coders/msl.c in ImageMagick before
6.9.9-5 and 7.x before 7.0.6-5 allows remote attackers to cause a
denial of service (memory leak) via a crafted file, related to the
WriteMSLImage function.

echo "" >output.msl
valgrind convert Memory-Leak-19_output_msl_1501504023.36 output.msl

The memory leak is not directly visible, but several other warnings are shown. Our packages miss the various free'ing statements.

References:
http://web.nvd.nist.gov/view/vuln/detail?vulnId=CVE-2017-12427
http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2017-12427
Comment 1 Marcus Meissner 2017-09-29 06:11:28 UTC
https://github.com/ImageMagick/ImageMagick/commit/e793eb203e5e0f91f5037aed6585e81b1e27395b

https://github.com/ImageMagick/ImageMagick/issues/636

One of the components that can be memory leaked is image sized, attacker controlled.
Comment 2 Petr Gajdos 2018-02-16 13:39:04 UTC
12/ImageMagick

$ echo "" >output.msl
$ valgrind -q --leak-check=full convert Memory-Leak-19_output_msl_1501504023.36 output.msl
convert: unexpected end-of-file `Memory-Leak-19_output_msl_1501504023.36' @ error/pwp.c/ReadPWPImage/198.
convert: no images defined `output.msl' @ error/convert.c/ConvertImageCommand/3149.
$
[no issues observed]

11/ImageMagick

$ echo "" >output.msl
$ valgrind -q --leak-check=full convert Memory-Leak-19_output_msl_1501504023.36 output.msl
convert: Unexpected end-of-file `Memory-Leak-19_output_msl_1501504023.36': No such file or directory.
$
[no issues observed]

11/GraphicsMagick

$ echo "" >output.msl
$ valgrind -q --leak-check=full gm convert Memory-Leak-19_output_msl_1501504023.36 output.msl
==7682== Use of uninitialised value of size 8
==7682==    at 0x4F23A28: LocaleNCompare (utility.c:3356)
==7682==    by 0x85943CB: ReadPWPImage (pwp.c:177)
==7682==    by 0x4EA01CC: ReadImage (constitute.c:6000)
==7682==    by 0x4E8CBCF: ConvertImageCommand (command.c:3171)
==7682==    by 0x4E73683: MagickCommand (command.c:7657)
==7682==    by 0x4E737FE: GMCommand (command.c:15277)
==7682==    by 0x76E2585: (below main) (in /lib64/libc-2.9.so)
gm convert: Request did not return an image.
$
[no leaks observed]

42.3/GraphicsMagick

$ echo "" >output.msl
$ valgrind -q --leak-check=full gm convert Memory-Leak-19_output_msl_1501504023.36 output.msl
==7692== Use of uninitialised value of size 8
==7692==    at 0x4F3DC1E: LocaleNCompare (utility.c:3520)
==7692==    by 0x816B2E8: ReadPWPImage (pwp.c:177)
==7692==    by 0x4EBEB77: ReadImage (constitute.c:1607)
==7692==    by 0x4E9F037: ConvertImageCommand (command.c:4348)
==7692==    by 0x4E8F884: MagickCommand (command.c:8868)
==7692==    by 0x4E9099D: GMCommandSingle (command.c:17376)
==7692==    by 0x4EB1D2D: GMCommand (command.c:17429)
==7692==    by 0x54406E4: (below main) (in /lib64/libc-2.22.so)
==7692== 
gm convert: Request did not return an image.
$
[no leaks observed]

PATCH

https://github.com/ImageMagick/ImageMagick/commit/841f7b27dc88c685c61252d59b7e20e94c982456
http://hg.code.sf.net/p/graphicsmagick/code/diff/075a1eea2838/coders/msl.c

12/ImageMagick: needs the patch
11/ImageMagick: needs the patch
11/GraphicsMagick: needs the patch
42.3/GraphicsMagick: already fixed

AFTER

Output does not change.
Comment 3 Petr Gajdos 2018-02-16 16:39:01 UTC
Will submit for 12/ImageMagick, 11/ImageMagick and 11/GraphicsMagick.
Comment 4 Petr Gajdos 2018-02-16 19:16:41 UTC
Packages submitted.
Comment 7 Swamp Workflow Management 2018-02-20 14:09:07 UTC
SUSE-SU-2018:0486-1: An update that fixes 24 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1042824,1048110,1049374,1049375,1050048,1050617,1050669,1052207,1052248,1052251,1052254,1052472,1052688,1052711,1052747,1052750,1052761,1055069,1055229,1058009,1074119,1076182,1078433
CVE References: CVE-2017-11166,CVE-2017-11448,CVE-2017-11450,CVE-2017-11537,CVE-2017-11637,CVE-2017-11638,CVE-2017-11642,CVE-2017-12418,CVE-2017-12427,CVE-2017-12429,CVE-2017-12432,CVE-2017-12566,CVE-2017-12654,CVE-2017-12664,CVE-2017-12665,CVE-2017-12668,CVE-2017-12674,CVE-2017-13058,CVE-2017-13131,CVE-2017-14224,CVE-2017-17885,CVE-2017-18028,CVE-2017-9407,CVE-2018-6405
Sources used:
SUSE Linux Enterprise Software Development Kit 11-SP4 (src):    ImageMagick-6.4.3.6-7.78.34.1
SUSE Linux Enterprise Server 11-SP4 (src):    ImageMagick-6.4.3.6-7.78.34.1
SUSE Linux Enterprise Debuginfo 11-SP4 (src):    ImageMagick-6.4.3.6-7.78.34.1
Comment 9 Swamp Workflow Management 2018-02-22 14:09:16 UTC
SUSE-SU-2018:0524-1: An update that fixes 20 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1042824,1047900,1049374,1049375,1050617,1050669,1052248,1052251,1052254,1052472,1052688,1055069,1055229,1058009,1072934,1073081,1074307,1076182,1078433
CVE References: CVE-2017-11140,CVE-2017-11448,CVE-2017-11450,CVE-2017-11637,CVE-2017-11638,CVE-2017-11642,CVE-2017-12427,CVE-2017-12429,CVE-2017-12432,CVE-2017-12566,CVE-2017-12668,CVE-2017-13058,CVE-2017-13131,CVE-2017-14224,CVE-2017-17502,CVE-2017-17503,CVE-2017-17912,CVE-2017-18028,CVE-2017-9407,CVE-2018-6405
Sources used:
SUSE Studio Onsite 1.3 (src):    GraphicsMagick-1.2.5-4.78.38.1
SUSE Linux Enterprise Software Development Kit 11-SP4 (src):    GraphicsMagick-1.2.5-4.78.38.1
SUSE Linux Enterprise Debuginfo 11-SP4 (src):    GraphicsMagick-1.2.5-4.78.38.1
Comment 10 Swamp Workflow Management 2018-03-01 20:16:31 UTC
SUSE-SU-2018:0581-1: An update that fixes 35 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1042824,1042911,1048110,1048272,1049374,1049375,1050048,1050119,1050122,1050126,1050132,1050617,1052207,1052248,1052251,1052254,1052472,1052688,1052711,1052747,1052750,1052754,1052761,1055069,1055229,1056768,1057163,1058009,1072898,1074119,1074170,1075821,1076182,1078433
CVE References: CVE-2017-11166,CVE-2017-11170,CVE-2017-11448,CVE-2017-11450,CVE-2017-11528,CVE-2017-11530,CVE-2017-11531,CVE-2017-11533,CVE-2017-11537,CVE-2017-11638,CVE-2017-11642,CVE-2017-12418,CVE-2017-12427,CVE-2017-12429,CVE-2017-12432,CVE-2017-12566,CVE-2017-12654,CVE-2017-12663,CVE-2017-12664,CVE-2017-12665,CVE-2017-12668,CVE-2017-12674,CVE-2017-13058,CVE-2017-13131,CVE-2017-14060,CVE-2017-14139,CVE-2017-14224,CVE-2017-17682,CVE-2017-17885,CVE-2017-17934,CVE-2017-18028,CVE-2017-9405,CVE-2017-9407,CVE-2018-5357,CVE-2018-6405
Sources used:
SUSE Linux Enterprise Workstation Extension 12-SP3 (src):    ImageMagick-6.8.8.1-71.42.1
SUSE Linux Enterprise Workstation Extension 12-SP2 (src):    ImageMagick-6.8.8.1-71.42.1
SUSE Linux Enterprise Software Development Kit 12-SP3 (src):    ImageMagick-6.8.8.1-71.42.1
SUSE Linux Enterprise Software Development Kit 12-SP2 (src):    ImageMagick-6.8.8.1-71.42.1
SUSE Linux Enterprise Server for Raspberry Pi 12-SP2 (src):    ImageMagick-6.8.8.1-71.42.1
SUSE Linux Enterprise Server 12-SP3 (src):    ImageMagick-6.8.8.1-71.42.1
SUSE Linux Enterprise Server 12-SP2 (src):    ImageMagick-6.8.8.1-71.42.1
SUSE Linux Enterprise Desktop 12-SP3 (src):    ImageMagick-6.8.8.1-71.42.1
SUSE Linux Enterprise Desktop 12-SP2 (src):    ImageMagick-6.8.8.1-71.42.1
Comment 11 Andreas Stieger 2018-03-06 19:44:31 UTC
Releasing for Leap, showing as done otherwise
Comment 12 Swamp Workflow Management 2018-03-06 23:15:15 UTC
openSUSE-SU-2018:0621-1: An update that fixes 35 vulnerabilities is now available.

Category: security (moderate)
Bug References: 1042824,1042911,1048110,1048272,1049374,1049375,1050048,1050119,1050122,1050126,1050132,1050617,1052207,1052248,1052251,1052254,1052472,1052688,1052711,1052747,1052750,1052754,1052761,1055069,1055229,1056768,1057163,1058009,1072898,1074119,1074170,1075821,1076182,1078433
CVE References: CVE-2017-11166,CVE-2017-11170,CVE-2017-11448,CVE-2017-11450,CVE-2017-11528,CVE-2017-11530,CVE-2017-11531,CVE-2017-11533,CVE-2017-11537,CVE-2017-11638,CVE-2017-11642,CVE-2017-12418,CVE-2017-12427,CVE-2017-12429,CVE-2017-12432,CVE-2017-12566,CVE-2017-12654,CVE-2017-12663,CVE-2017-12664,CVE-2017-12665,CVE-2017-12668,CVE-2017-12674,CVE-2017-13058,CVE-2017-13131,CVE-2017-14060,CVE-2017-14139,CVE-2017-14224,CVE-2017-17682,CVE-2017-17885,CVE-2017-17934,CVE-2017-18028,CVE-2017-9405,CVE-2017-9407,CVE-2018-5357,CVE-2018-6405
Sources used:
openSUSE Leap 42.3 (src):    ImageMagick-6.8.8.1-55.1